global nametracker
clearlistener()

inputlist = "D:\\DEADORALIVE5\\filelist.txt"
outputlist = "D:\\DEADORALIVE5\\renamelist.txt"

index=1
backwards = false
arrayid = false
inArray=#()
outArray=#()

if (doesFileExist inputlist)==false do(
messagebox "Please Open Text File Containing A List Encrypted Names"
inputlist = GetOpenFileName \
caption:"Encrypted Names" \
types: "All files (*.*)|*.*|"
)
if (doesFileExist outputlist)==false do(
messagebox "Please Open Text File Containing A List of New Names"
outputlist = GetOpenFileName \
caption:"New Names" \
types: "All files (*.*)|*.*|"
)

if inputlist!=undefined AND outputlist!=undefined then (

f=MemStreamMgr.openFile inputlist

while f.eos() != true do (append inArray (f.readLine()))
MemStreamMgr.close f
f=MemStreamMgr.openFile outputlist
outArray[inArray.count]=""
for i = 1 to inArray.count do (
str=(f.readLine());if str!=undefined then(outArray[i]=str)else(outArray[i]=""))
MemStreamMgr.close f

try (destroydialog nametracker)catch()
rollout nametracker "Name Manager" width:470 height:311
(
	button btn1 "SAVE" pos:[169,256] width:122 height:31
	listBox lbx1 "" pos:[24,82] width:422 height:11 items:outArray
	listBox lbx2 "" pos:[24,82] width:422 height:11 items:inArray visible:false enabled:false
	editText edt2 "Label:" pos:[22,48] width:422 height:16
	checkbox chk1 "Reversed Names" pos:[25,242] width:124 height:18 checked:backwards
	checkbox chk2 "Rename Mode" pos:[25,262] width:124 height:18 checked:backwards
	editText edt1 "Find:" pos:[29,15] width:415 height:16
	button btn2 "Switch View" pos:[366,240] width:80 height:18
	button btn3 "RENAME" pos:[169,256] width:122 height:31 visible:false enabled:false

	fn reversestring instring = (
outstring=copy instring
for i = 1 to instring.count do (
idx = instring.count-(i-1)
outstring[i]=instring[idx]);outstring)
	

on lbx1 selected nameIndex do (
lbx2.selection = nameIndex
)

on lbx2 selected nameIndex do (
lbx1.selection = nameIndex
)

on lbx1 doubleClicked itm do (
index = itm
edt1.text = inArray[index]
edt2.text = outArray[index]
)
on lbx2 doubleClicked itm do (
index = itm
edt1.text = inArray[index]
edt2.text = outArray[index]
)
	on chk2 changed theState do (
	if theState==true then (
	btn1.visible = false
	btn1.enabled = false
	btn3.visible = true
	btn3.enabled = true
	)else(
	btn1.visible = true
	btn1.enabled = true
	btn3.visible = false
	btn3.enabled = false
	)

)
on chk1 changed theState do (
backwards=theState
)
on btn2 pressed do(
if arrayid == false then(
arrayid=true
lbx1.visible = false
lbx2.visible = true
lbx1.enabled = false
lbx2.enabled = true
)else(
arrayid=false
lbx1.visible = true
lbx2.visible = false
lbx1.enabled = true
lbx2.enabled = false
)
	
)

on btn3 pressed do(
messagebox "Files will be renamed to current view\nSelect any file in the folder you want to rename\n\nAll Files within that folder will get renamed.\nThere is NO Undo!"
rename = GetOpenFileName \
caption:"Select A file Within A Directory You Wish to Recursively Rename" \
types: "All files (*.*)|*.*|"
counter = 0
if rename!=undefined then (
rpath = getFilenamePath rename
rename=getFiles (rpath+"*.*")
format "Files Collected: %\n" rename.count
if lbx1.enabled == true then (
for i = 1 to rename.count do (
find = findItem inArray (getFilenameFile rename[i])
if backwards==true AND find==0 do (find = findItem inArray (reversestring (getFilenameFile rename[i])))
if find!=0 do (str=outArray[find];if str!="" do (ren=renameFile rename[i] (rpath+str);if ren==true do (counter+=1)))
)
)else(
if backwards==false then(
for i = 1 to rename.count do (
find = findItem outArray (filenameFromPath rename[i])
if find!=0 do (str=inArray[find];if str!="" do (ren=renameFile rename[i] (rpath+str);if ren==true do (counter+=1)))
)
)else(
for i = 1 to rename.count do (
find = findItem outArray (filenameFromPath rename[i])
if find!=0 do (str=(reversestring inArray[find]);if str!="" do (ren=renameFile rename[i] (rpath+str);if ren==true do (counter+=1)))
)
)
)
messagebox ("Complete!\n"+(counter as string)+" Files Renamed")
)else(Print "Renaming Cancelled")	
)
on edt1 entered txt do (
if txt!="" do (edt1.text = txt)
if backwards==true then (
index = findItem inArray (reversestring edt1.text)
)else(
index = findItem inArray edt1.text)
if index==0 do (
index = findItem outArray edt1.text
if index!=0 do (edt1.text = inArray[index]))
if index!=0 then (
edt2.text = outArray[index]
lbx1.selection = index
lbx2.selection = index
)else(edt2.text = "undefined")
)
on edt2 entered txt do (
-- format "Input: %\n" txt
if txt!="" do (edt2.text = txt)
if index!=0 do (
outArray[index]=edt2.text
)
)
on btn1 pressed do(
s=fopen outputlist "wb"
for i = 1 to outArray.count do(
for x = 1 to outArray[i].count do (
writebyte s (bit.charAsInt outArray[i][x]) #unsigned
)
writeshort s 0x0A0D #unsigned
)
fclose s
lbx1.items = inArray
lbx2.items = outArray
messagebox "Done!"
)
);createdialog nametracker
)else(MessageBox "Error Failed to Find Name Listings!")